﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Public gvh As GameViewHelper
	
	Private per 				As Period
	
	Public  Root	 			As B4XView
	Private xui 				As XUI
	Private pnlMenu 			As B4XView
	Private imvLogo 			As B4XImageView

	Private lblUser 			As Label
	Private lblUserName 		As Label
	Private lblNotifications 	As Label
	Private lblClose 			As Label
	Public  lblInfo1 			As Label
	Public  lblMessage 			As Label
	Private lblInfo2 			As Label
	Private lblInfo3 			As Label
	Private lblInfo4 			As Label
	Private imvIcon 			As B4XImageView
	Private appCalendar 		As VFCalendar
	
	Private lblMonthName 		As Label
	Private lblYear 			As Label
	Private lblCalNext 			As Label
	Private lblCalPrev 			As Label
	Private lblToday 			As Label
	Private clvMenu 			As CustomListView
	
	Private lblMenu		 		As Label
	Private lblMenuIcon 		As Label
	
	Private lblSelected 		As Label
	
	Public  vpForms 			As TabPane
	
	Private RDC 				As jRDC
	
	Private dialogExit 			As B4XDialog
	
	Public  lblStockBadge 		As Label
	Public  lblAppBadge 		As Label
	
End Sub

Public Sub Initialize
	gvh.AddKeyListener("keylistener", Main.MainForm)
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	Metro.ApplyTheme(Main.MainForm,"Dark")
	
	'BMStyle.ApplyTheme(Main.MainForm, Array As String("breeze.css"))
	
	RDC.Initialize
	
	stockUtils.initialize
	
	stylePage
	makeMenu
	addPages
    
	'B4XPages.GetManager.LogEvents = True
		
End Sub

Private Sub stylePage
	#If B4J
	appCalendar.AppointmentType2_ItemPropertiest.height = 15dip
	#End If
	
	appCalendar.ShowFirstWeekOfMonthInFirstRow = True
	appCalendar.FirstDayOfWeek = 5
	appCalendar.ShowOtherMonths = False
	'Call this to Build the calendar, unfortunately this is needed, otherwise runtime errors will occur
	'Call this after you set all properties you want
	appCalendar.CreateCalendar
	lblMonthName.Text = DateUtils.GetMonthName(appCalendar.SelectedDate)
	lblYear.Text = DateTime.GetYear(appCalendar.SelectedDate)
	
	clvMenu.AsView.SetColorAndBorder(xui.Color_ARGB(255,0,56,70),0,0,0)
	clvMenu.sv.SetColorAndBorder(xui.Color_ARGB(255,0,56,70),0,0,0)
	clvMenu.GetBase.SetColorAndBorder(xui.Color_ARGB(255,0,56,70),0,0,0)
	
	SetMinMaxTabSize(vpForms,0dip,0dip)
	
	dialogExit.Initialize(Root)
	
	lblStockBadge.Visible = False
	lblAppBadge.Visible = False
	
	per.Initialize
	per.Days = 13
	
End Sub

private Sub makeMenu
	Private req As DBRequestManager = RDC.CreateRequest(Me)
	Private cmd As DBCommand = RDC.CreateCommand("select_menu", Null)
	
	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
	If j.Success Then
		req.HandleJobAsync(j, "req")
		Wait For (req) req_result(res As DBResult)
		
		For Each row() As Object In res.Rows
			Private iconD As String = IIf(row(7) <> Null And row(7) <> "null",row(7),"")
			clvMenu.Add(CreateItem(60dip, row(1), iconD), iconD)
		Next
		
	End If
	
	Private pf As Pane
	pf.Initialize("")
	pf.Alpha = 0
	pf.PrefWidth = pnlMenu.Width
	pf.PrefHeight = pnlMenu.Height - (clvMenu.Size - 1) * 60dip
	clvMenu.Add(pf,99)
	
	If clvMenu.Size > 0 Then
		Private p As Pane = clvMenu.GetPanel(1)
		Private l As Label
		l = p.GetNode(2)
		l.Visible = True
	End If
	
	stockUtils.checkLowStockItems
	
End Sub

Private Sub lblCalPrev_MouseClicked (EventData As MouseEvent)
	appCalendar.PreviousWeek
End Sub

Private Sub lblCalNext_MouseClicked (EventData As MouseEvent)
	appCalendar.NextWeek
End Sub

Private Sub lblYear_MouseClicked (EventData As MouseEvent)
	
End Sub

Private Sub lblMonthName_MouseClicked (EventData As MouseEvent)
	
End Sub

Private Sub lblToday_MouseClicked (EventData As MouseEvent)
	appCalendar.Back2CurrentDate
	lblMonthName.Text = DateUtils.GetMonthName(DateUtils.AddPeriod(appCalendar.StartDate,per))
	lblYear.Text      = DateTime.GetYear(DateUtils.AddPeriod(appCalendar.StartDate,per))
End Sub

Private Sub appCalendar_SelectedDateChanged(Date As Long)
	lblMonthName.Text = DateUtils.GetMonthName(Date)
	lblYear.Text      = DateTime.GetYear(Date)
End Sub

Private Sub appCalendar_VisibleRangeChanged(StartDate As Long,EndDate As Long)
	lblMonthName.Text = DateUtils.GetMonthName(DateUtils.AddPeriod(StartDate,per))
	lblYear.Text      = DateTime.GetYear(DateUtils.AddPeriod(StartDate,per))
	
	Private sundays As List = appCalendar.GetDaysBetween2Dates(StartDate,EndDate, 1)
	For Each s As Long In sundays
		appCalendar.AddSpecialDay(s,xui.Color_ARGB(255,221, 95, 96),"official_holiday")
	Next
	appCalendar.CommitSpecialDays
End Sub

Private Sub CreateItem(Width As Double, p As String, i As String) As B4XView
	Private pn As Pane
	pn.Initialize("pn")
	pn.SetLayoutAnimated(0, 0, 0, Width, 60dip)
	If i = "" Then
		pn.LoadLayout("menugroup")
	Else
		pn.LoadLayout("menuitem")
		lblMenuIcon.Text = global.icons.Get(i)
		lblMenuIcon.Alignment = "CENTER"
		lblSelected.Alignment = "CENTER"
	End If
	lblMenu.Text = p
	lblMenu.Alignment = "CENTER_LEFT"
	Return pn
End Sub

Private Sub clvMenu_ItemClick (Index As Int, Value As Object)
	If Value <> "" Then
		
		If Value = "bluetooth" Then
			fBTDevices.initialize
			Return
		End If
		
		Private i As Int
		
		For i = 0 To clvMenu.Size - 1
			Private p As Pane = clvMenu.GetPanel(i)
			Private l As Label
			
			Try
				l = p.GetNode(2)
			Catch
				Continue
			End Try
			
			If (i <> Index) Then
				l.Visible = False
			Else
				l.Visible = True
			End If
		Next
		
		vpForms.SelectedIndex = Index - 1
		
		Sleep(0)
		Select Index
			Case 1
				fSuppliers.txtCode.RequestFocus
			Case 2
				fCustomers.txtCode.RequestFocus
		End Select
		
	End If
	
End Sub

Private Sub addPages
	fSuppliers.initialize
	fCustomers.initialize
End Sub

Sub SetMinMaxTabSize(tp As TabPane, width As Double, height As Double)
	Dim jo As JavaObject = tp
	jo.RunMethod("setTabMaxWidth", Array(width))
	jo.RunMethod("setTabMaxHeight", Array(height))
	jo.RunMethod("setTabMinWidth", Array(width))
	jo.RunMethod("setTabMinHeight", Array(height))
End Sub

Private Sub lblClose_MousePressed (EventData As MouseEvent)
	ShowDialogExit
End Sub

Sub ShowDialogExit
	dialogExit.Title = "Κλείσιμο Εφαρμογής"
	dialogExit.BackgroundColor = xui.Color_RGB(30,30,40)
	dialogExit.TitleBarColor = xui.Color_RGB(0,56,70)
	dialogExit.ButtonsColor = xui.Color_RGB(0,150,190)
	Wait For (dialogExit.Show("Θέλετε σίγουρα να κλείσετε την Εφαρμογή;", "ΝΑΙ", "ΟΧΙ", "")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		ExitApplication
	End If
End Sub


Private Sub lblNotifications_MousePressed (EventData As MouseEvent)
	If lblStockBadge.Visible Then
		stockUtils.ShowDialogLowStock
	End If
End Sub
