﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=3.61
@EndOfDesignText@
'Static code module
Sub Process_Globals
    Public module_size As Double  'so you can calculate the estimated size 
    Private fore_color As Paint
	Private back_color As Paint
	Private fx As JFX
	Private sf As StringUtilities
	Private gf As Int = 256  'define the Size & Prime Polynomial of this Galois field...
	Private PP As Int = 285  '...for QR codes
	Private logg(256) As Int
    Private alogg(512) As Int
	Private gf_mul_result As Int
	Private s4c4(37) As Int
	Private s4c24(35) As Int 
	Private s4c1(301) 
	Private z(4000) As Int 
	Private message_coeff(2956) As Int   'might have to change to accommodate versions >15 with max data
	Private s5cij(180,180) As Int        'dimensioned for up to version 40 QR codes (177 x 177)
	Private version_no, max_mod, qr_size As Int
    Private error_level As String
	Private a As String
	Private b As String
	Private q As String
	Private tel2 As Int
	Private anew As String
	Private ECC_woord As String
	Private no_of_error_words,mess_coef_teller As Int
	Private block1,block2,dw1,dw2,ew1,ew2 As Int
	Private max_data_bits As Int
	Private maxlen As Int
	Private tipe As String
	Private maskp As Int
    Private dat As String
	Private ver1(), ver2(), ver3(), ver4(), ver5(), ver6(), ver7(), ver8(), ver9(), ver10() As Int	
	Private ver11(), ver12(), ver13(), ver14(), ver15(), ver16(), ver17(), ver18(), ver19(), ver20()As Int
	Private ver21(), ver22(), ver23(), ver24(), ver25(), ver26(), ver27(), ver28(), ver29(), ver30() As Int	
	Private ver31(), ver32(), ver33(), ver34(), ver35(), ver36(), ver37(), ver38(), ver39(), ver40()As Int
	
'New:	 
	Dim ver(41, 80) As Int
	
End Sub


'Description: Generates a QR code
'
'Method of calling:
'module_size = 3
'fcolor = fx.Colors.Green
'bcolor = fx.Colors.White
'msg = "Developed by Johan Schoeman, 5 Berkley, 3 Wells Close, Somerset Park, Durban, South Africa" & Chr(13) & "johan@barrierfilm.co.za" & Chr(13) & "www.astrapak.co.za"
'Canvas9 = QRcode.Draw_QR_Code(msg, error_level, mask_pattern, fore_color, back_color, module_size, Canvas9)
'
'where 'msg' = message to be encoded - type String
'where 'error_level' = the required error level ("L", "M", "Q", "H") - type String
'where 'mask_pattern' = the masking pattern to apply (0 to 7) - type Int
'where 'fore_color' = the color of the modules that represents a 1 - type Paint
'where 'back_color' = the color of the modules that represents a 0 - type Paint
'where 'module_size' = the size of a module representing a 1 or a 0 - type Double

Public Sub Draw_QR_Code(message As String, err_lvl As String, mask As Int, fc As Paint, bc As Paint, modsize As Double, c As Canvas) As Canvas

Add2Array

module_size = modsize
fore_color = fc
back_color = bc
sf.Initialize
'Log(message & " " & err_lvl & " " & mask)
Dim QRSTRING As String
Dim len_dat As Int
Dim rev_len_dat_bin As String
Dim len_dat_bin As String
dat = message
'version_no = ver_numb
error_level = err_lvl
tipe = "8-bit-Byte"
maskp = mask

'set_initial_value
ECC_woord = ""

determine_max_len

Dim V1 As Int =version_no/10

select_block

QRSTRING = ""

Select Case tipe              'get the correct mode indicator
  Case "Numeric"
    QRSTRING = "0001"
  Case "Alphanumeric"
    QRSTRING = "0010"
  Case "8-bit-Byte"
    QRSTRING = "0100"
End Select

Generate_log_antilog
'determine_max_len

If sf.stringLength(dat) > maxlen Then   'only encode the maximum alowable number of chars based on selection of Version, ECC level, encoding mode
  dat = sf.Left(dat, maxlen)
End If

len_dat = sf.stringLength(dat)
rev_len_dat_bin = ""       'this will hold a binary string but it will be in reverse order i.e LSB to MSB

Dim a1 As Int
Dim b1 As Int
Dim c1 As Int

a1 = len_dat    'get the binary string for the length of data. It is initially in reverse order

Do While a1 <> 0          
  b1 = Floor(a1 / 2)
  c1 = a1 - (b1 * 2)
  If c1 = 1 Then rev_len_dat_bin = rev_len_dat_bin & "1"
  If c1 = 0 Then rev_len_dat_bin = rev_len_dat_bin & "0"
  a1 = b1
Loop

len_dat_bin = ""     'now reverse the sting that is in reversed order
For i = 1 To sf.stringLength(rev_len_dat_bin)
  len_dat_bin = sf.Mid(rev_len_dat_bin, i, 1) & len_dat_bin    'reverse the binary string to be MSB to LSB
Next 

rev_len_dat_bin = sf.Trim(rev_len_dat_bin)
len_dat_bin = sf.Trim(len_dat_bin)

If tipe = "8-bit-Byte" Then
    If version_no >= 1 And version_no <= 9 Then  'version 1 to 9 for 8-bit byte mode
        If sf.stringLength(len_dat_bin) < 8 Then
          Do While sf.stringLength(len_dat_bin) < 8
            len_dat_bin = "0" & len_dat_bin    'add a leading zero to get the length indicator to be 8 bits long
          Loop       
        End If
    Else If version_no > 9 Then
        If sf.stringLength(len_dat_bin) < 16 Then
          Do While sf.stringLength(len_dat_bin) < 16 
            len_dat_bin = "0" & len_dat_bin   'add a leading zero to get the length indicator to be 16 bits long
          Loop        
        End If
    End If
Else If tipe = "Numeric" Then
    If version_no >= 1 And version_no <= 9 Then  'version 1 to 9 for 8-bit byte mode
        If sf.stringLength(len_dat_bin) < 10 Then
          Do While sf.stringLength(len_dat_bin) < 10
            len_dat_bin = "0" & len_dat_bin  'add a leading zero to get the length indicator to be 10 bits long
          Loop        
        End If
    Else If version_no >= 10 And version_no <= 26 Then
        If sf.stringLength(len_dat_bin) < 12 Then
          Do While sf.stringLength(len_dat_bin) < 12 
            len_dat_bin = "0" & len_dat_bin   'add a leading zero to get the length indicator to be 12 bits long
          Loop       
        End If
    Else If version_no > 26 Then
        If sf.stringLength(len_dat_bin) < 14 Then
          Do While sf.stringLength(len_dat_bin) < 14  
            len_dat_bin = "0" & len_dat_bin 'add a leading zero to get the length indicator to be 14 bits long
          Loop      
        End If
    End If
Else If tipe = "Alphanumeric" Then
    If version_no >= 1 And version_no <= 9 Then  'version 1 to 9 for 8-bit byte mode
        If sf.stringLength(len_dat_bin) < 9 Then
          Do While sf.stringLength(len_dat_bin) < 9 
            len_dat_bin = "0" & len_dat_bin 'add a leading zero to get the length indicator to be 9 bits long
          Loop       
        End If
    Else If version_no > 9 And version_no < 27 Then
        If sf.stringLength(len_dat_bin) < 11 Then
          Do While sf.stringLength(len_dat_bin) < 11 
            len_dat_bin = "0" & len_dat_bin 'add a leading zero to get the length indicator to be 11 bits long
          Loop       
        End If
    Else If version_no > 26 Then
        If sf.stringLength(len_dat_bin) < 13 Then
          Do While sf.stringLength(len_dat_bin) < 13  
            len_dat_bin = "0" & len_dat_bin 'add a leading zero to get the length indicator to be 13 bits long
          Loop     
        End If
    End If
End If

QRSTRING = QRSTRING & len_dat_bin 'data type number (4 bits long - type) + input string length (padded to correct length)

Dim char_to_convert As String
Dim waarde As Int
Dim getal As String

If tipe = "8-bit-Byte" Then
  For i = 1 To len_dat
    char_to_convert = sf.Mid(dat, i, 1)   'get each individual char in the string
    waarde = conv(char_to_convert)       'get the ASCII value for the chars
    z(i) = waarde                         'store the ASCII values in z()
  Next
  For i = 1 To len_dat
    getal = convert_to_binary(z(i))     'convert each ASCII value to binary equivalent
    If sf.stringLength(getal) < 8 Then            'and then pad it with leading zeros to be 8 bits long
      Do While sf.stringLength(getal) < 8
        getal = "0" & getal
      Loop 
    End If

    QRSTRING = QRSTRING & sf.Trim(getal)
  Next
End If

If tipe = "Alphanumeric" Then
    a1 = Floor(len_dat / 2)
    b1 = a1 * 2
    
    For i = 1 To len_dat
      char_to_convert = sf.Mid(dat, i, 1)
      waarde = anconv(char_to_convert)
      z(i) = waarde
    Next
    
    If len_dat - b1 = 1 Then                  'uneven number of chars in the input string
      For i = 1 To len_dat - 1 Step 2
        waarde = (z(i) * 45) + z(i + 1)
        getal = convert_to_binary(waarde)
        If sf.stringLength(getal) < 11 Then
          Do While sf.stringLength(getal) < 11 
            getal = "0" & getal
          Loop        'alphanumeric "words" must be 11 bits long
        End If
        QRSTRING = QRSTRING & sf.Trim(getal)
       Next 
       waarde = z(len_dat)
       getal = convert_to_binary(waarde)
       If sf.stringLength(getal) < 6 Then               'do the uneven numbered char
         Do While sf.stringLength(getal) < 6  
           getal = "0" & getal
         Loop         'pad it with zeros - it needs to be 6 bits long
       End If
       QRSTRING = QRSTRING & sf.Trim(getal)
    End If
    
    If len_dat - b1 = 0 Then                  'even number of chars in the input sting
      For i = 1 To len_dat - 1 Step 2
        waarde = (z(i) * 45) + z(i + 1)
        getal = convert_to_binary(waarde)
        If sf.stringLength(getal) < 11 Then
          Do While sf.stringLength(getal) < 11
            getal = "0" & getal
          Loop
        End If
        QRSTRING = QRSTRING & sf.Trim(getal)
      Next 
    End If
End If

If tipe = "Numeric" Then

    a1 = Floor(len_dat / 3 )                       'going to pack 3 chars per 10 bits
    b1 = a1 * 3                               'how many multiples of 3 chars in the input string
    
    If len_dat - b1 = 2 Then                  'remainder of two chars
      For i = 1 To len_dat - 2 Step 3
        waarde = sf.Val(sf.Mid(dat, i, 3))
        getal = convert_to_binary(waarde)
        If sf.stringLength(getal) < 10 Then
          Do While sf.stringLength(getal) < 10 
            getal = "0" & getal
          Loop        'numeric "words" must be 10 bits long
        End If
        QRSTRING = QRSTRING & sf.Trim(getal)
       Next 
       waarde = sf.Val(sf.Mid(dat, i, 2))
       getal = convert_to_binary(waarde)
       If sf.stringLength(getal) < 7 Then               '2 remaining chars represented by 7 bits
         Do While sf.stringLength(getal) < 7 
           getal = "0" & getal
         Loop          'pad it with zeros - it needs to be 7 bits long
       End If
       QRSTRING = QRSTRING & sf.Trim(getal)
    End If

  
    If len_dat - b1 = 1 Then                  'remainder of 1 char
      For i = 1 To len_dat - 1 Step 3
        waarde = sf.Val(sf.Mid(dat, i, 3))
        getal = convert_to_binary(waarde)
        If sf.stringLength(getal) < 10 Then
          Do While sf.stringLength(getal) < 10  
            getal = "0" & getal
          Loop       'numeric "words" must be 10 bits long
        End If
        QRSTRING = QRSTRING & sf.Trim(getal)
       Next 
       waarde = sf.Val(sf.Mid(dat, i, 1))
       getal = convert_to_binary(waarde)
       If sf.stringLength(getal) < 4 Then               'one remaining char represented by 4 bits
         Do While sf.stringLength(getal) < 4 
           getal = "0" & getal
         Loop          'pad it with zeros - it needs to be 4 bits long
       End If
       QRSTRING = QRSTRING & sf.Trim(getal)
    End If
      
    If len_dat - b1 = 0 Then                  'multiple of 3 chars in the input string
      For i = 1 To len_dat Step 3
        waarde = sf.Val(sf.Mid(dat, i, 3))
        getal = convert_to_binary(waarde)
        If sf.stringLength(getal) < 10 Then
          Do While sf.stringLength(getal) < 10  
            getal = "0" & getal
          Loop       'numeric "words" must be 10 bits long
        End If
        QRSTRING = QRSTRING & sf.Trim(getal)
       Next 
    End If

End If

If sf.stringLength(QRSTRING) <= max_data_bits - 4 Then      'add 4 zeros if length is not at least max_data_bits minus 4 long
   QRSTRING = QRSTRING & "0000"
 Else
   Do While sf.stringLength(QRSTRING) < max_data_bits
    QRSTRING = QRSTRING & "0"
   Loop   'else if longer then add just enough zeros until it is max_data_bits long
 End If



a1 = sf.stringLength(QRSTRING)
b1 = a1 Mod 8         'check if the sting is multiples of 8 bits

If b1 <> 0 Then
  Do While sf.stringLength(QRSTRING) Mod 8 <> 0
   QRSTRING = QRSTRING & "0"         'if not, then pad with zeros until it is multiples of 8 bits
  Loop 
End If

Dim last_flag As Int
last_flag = 0
If sf.stringLength(QRSTRING) < max_data_bits Then           'if still less than max_data_bits then add stings below alternatively
  Do While sf.stringLength(QRSTRING) <> max_data_bits  
    If last_flag = 0 Then
      QRSTRING = QRSTRING & "11101100"    'pad the sting alternatively with.....
      last_flag = 1
    Else
     QRSTRING = QRSTRING & "00010001"     '....and with....
     last_flag = 0
    End If
  Loop         'sting must be max_data_bits long
End If

Dim teller As Int

If dw2 <> 0 Then
  Dim data_block(block1 + block2 + 1, dw2 + 1) As Int
  For j = 1 To dw2
    For i = 1 To block1 + block2
      data_block(i, j) = 0              'load the array with zeros
    Next 
  Next 
  teller = 1
  For i = 1 To block1                     'load the order in which the data block will assembled to for the interleaved data string
    For j = 1 To dw1
      data_block(i, j) = teller
      teller = teller + 1
    Next 
  Next 
  For i = block1 + 1 To block1 + block2                      'load the order in which the data block will assembled to for the interleaved data string
    For j = 1 To dw2
      data_block(i, j) = teller
      teller = teller + 1
    Next 
  Next 
Else
  Dim data_block(block1 + block2 + 1 , dw1 + 1) As Int
  For j = 1 To dw1
    For i = 1 To block1
      data_block(i, j) = 0              'load the array with zeros
    Next 
  Next 
  teller = 1
  For i = 1 To block1                      'load the order in which the data block will assembled to for the interleaved data string
    For j = 1 To dw1
      data_block(i, j) = teller
      teller = teller + 1
    Next 
  Next 
End If

Dim ecc_block(block1 + block2 + 1, ew1 + 1) As Int  'could also be ew2 -> they are the same size
For j = 1 To ew1
  For i = 1 To block1 + block2
    ecc_block(i, j) = 0              'load the array with zeros
  Next 
Next 

teller = 1
For i = 1 To block1 + block2                      'load the order in which the data block will assembled to for the interleaved data string
  For j = 1 To ew1
    ecc_block(i, j) = teller
    teller = teller + 1
  Next 
Next 

Dim begin,einde,vlag,dec_answer As Int
Dim string_to_convert As String

begin = 1
einde = dw1 * 8
vlag = 0
Do While vlag <> block1 + block2  
  no_of_error_words = ew1
  mess_coef_teller = 1
  If vlag < block1 Then
    For i = begin To einde Step 8
      string_to_convert = sf.Mid(QRSTRING, i, 8)
      dec_answer = convert_to_decimal(string_to_convert)   'get the decimal value
      message_coeff(mess_coef_teller) = dec_answer          'this is the message polynomial coefficients
      mess_coef_teller = mess_coef_teller + 1
   Next 
    begin = einde + 1
    If vlag = block1 - 1 Then
      einde = einde + dw2 * 8
    Else
      einde = einde + dw1 * 8
    End If
  End If

  If vlag >= block1 Then
    For i = begin To einde Step 8    'take portion of the data sting to calculate ECC words for
      string_to_convert = sf.Mid(QRSTRING, i, 8)
      dec_answer = convert_to_decimal(string_to_convert)   'get the decimal value
      message_coeff(mess_coef_teller) = dec_answer          'this is the message polynomial coefficients
      mess_coef_teller = mess_coef_teller + 1
    Next 
    begin = einde + 1
    einde = einde + dw2 * 8
  End If
  
  mess_coef_teller = mess_coef_teller - 1

  For i = 1 To 196
    s4c1(i) = ""
  Next 

  For i = 1 To mess_coef_teller
    s4c1(i) = message_coeff(i)
  Next 
  
  generator_polynomial(no_of_error_words)    'create the generator polynomial with 30 ECC words for each half of the complete data string i.e half of 1856 bits

  q = ECC_words          'calculate the ECC words for each half of the message polynomial
  vlag = vlag + 1
Loop    'do it for as many times as the number of data blocks that are required

a = QRSTRING
b = q   'first block of error correction words

anew = ""                       'now build a new interleaved string

If dw2 <> 0 Then
  For j = 1 To dw2
    For i = 1 To block1 + block2
      If data_block(i, j) <> 0 Then
        anew = anew & sf.Mid(a, data_block(i, j) * 8 - 7, 8) 'take 8 bits from the first half of the data sting...
      End If
    Next      'repeat this process until the whole data string has been interleaved
  Next 
End If

If dw2 = 0 Then
  For j = 1 To dw1
    For i = 1 To block1 + block2
      If data_block(i, j) <> 0 Then
        anew = anew & sf.Mid(a, data_block(i, j) * 8 - 7, 8) 'take 8 bits from the first half of the data sting...
      End If
    Next     'repeat this process until the whole data string has been interleaved
  Next  
End If

' anew now holds the interleaved string

Dim d, dnew As String
d = ""                           'now do the same interleaving with the two ECC word blocks
d = b
dnew = ""                        'this will be the interleaved ECC word string
  For j = 1 To ew1
    For i = 1 To block1 + block2
      If ecc_block(i, j) <> 0 Then
        dnew = dnew & sf.Mid(d, ecc_block(i, j) * 8 - 7, 8) 'take 8 bits from the first half of the data sting...
      End If
    Next      'repeat this process until the whole data string has been interleaved
  Next 

'&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

anew = anew & dnew       'now build one long string of interleaved data followed by interleaved ECC words

place_matrix_data(c)

Return c

End Sub

Private Sub conv (karak As String) As Int

Dim char1 As Int = Asc(karak)
Return char1

End Sub

Private Sub convert_to_decimal(bb As String) As Int 

	Dim waarde As Int
	waarde = 0    'convert binary to decimal
	For i = 1 To 8
	 If sf.Mid(bb, i, 1) = 1 Then
	   waarde = waarde + Power(2,(8 - i))
	 End If
	Next

Return waarde

End Sub

Private Sub Generate_log_antilog

logg(0) = 1
alogg(0) = 1

For i = 1 To 255       'set up log / anti-log tables
  alogg(i) = alogg(i - 1) * 2
  If alogg(i) >= gf Then 
    alogg(i) = Bit.Xor(alogg(i), PP)
  End If	
  logg(alogg(i)) = i
Next

For i = 256 To 511
   alogg(i) = alogg(i - 255)
Next

logg(alogg(255)) = 255 '# Set last missing elements in gf_log[]

'Log("done")

End Sub

Private Sub convert_to_binary(getal1 As String) As String

Dim rev_len_dat_bin, len_dat_bin As String
Dim e,f,g As Int

rev_len_dat_bin = ""
e = sf.Val(getal1)
If e <> 0 Then
	Do While e <> 0
	  f = Floor(e / 2)
	  g = e - (f * 2)
	  If g = 1 Then rev_len_dat_bin = rev_len_dat_bin & "1"
	  If g = 0 Then rev_len_dat_bin = rev_len_dat_bin & "0"
	  e = f
	Loop
	'reverse the binary string to get the order right
	len_dat_bin = ""
	For x = 1 To sf.stringLength(rev_len_dat_bin)
	  len_dat_bin = sf.Mid(rev_len_dat_bin, x, 1) & len_dat_bin
	Next

	rev_len_dat_bin = sf.Trim(rev_len_dat_bin)
	len_dat_bin = sf.Trim(len_dat_bin)

	getal1 = len_dat_bin
	
	Return getal1
Else
	getal1 = "00000000"
	Return getal1
End If

End Sub

Private Sub anconv(char1 As String) As Int

Dim agetal As Int

Select Case char1
  Case "0"
   agetal = 0
  Case "1"
   agetal = 1
  Case "2"
   agetal = 2
  Case "3"
   agetal = 3
  Case "4"
   agetal = 4
  Case "5"
   agetal = 5
  Case "6"
   agetal = 6
  Case "7"
   agetal = 7
  Case "8"
   agetal = 8
  Case "9"
   agetal = 9
  Case "A"
   agetal = 10
  Case "a"
   agetal = 10
  Case "B"
   agetal = 11
  Case "b"
   agetal = 11
  Case "C"
   agetal = 12
  Case "c"
   agetal = 12
  Case "D"
   agetal = 13
  Case "d"
   agetal = 13
  Case "E"
   agetal = 14
  Case "e"
   agetal = 14
  Case "F"
   agetal = 15
  Case "f"
   agetal = 15
  Case "G"
   agetal = 16
  Case "g"
   agetal = 16
  Case "H"
   agetal = 17
  Case "h"
   agetal = 17
  Case "I"
   agetal = 18
  Case "i"
   agetal = 18
  Case "J"
   agetal = 19
  Case "j"
   agetal = 19
  Case "K"
   agetal = 20
  Case "k"
   agetal = 20
  Case "L"
   agetal = 21
  Case "l"
   agetal = 21
  Case "M"
   agetal = 22
  Case "m"
   agetal = 22
  Case "N"
   agetal = 23
  Case "n"
   agetal = 23
  Case "O"
   agetal = 24
  Case "o"
   agetal = 24
  Case "P"
   agetal = 25
  Case "p"
   agetal = 25
  Case "Q"
   agetal = 26
  Case "q"
   agetal = 26
  Case "R"
   agetal = 27
  Case "r"
   agetal = 27
  Case "S"
   agetal = 28
  Case "s"
   agetal = 28
  Case "T"
   agetal = 29
  Case "t"
   agetal = 29
  Case "U"
   agetal = 30
  Case "u"
   agetal = 30
  Case "V"
   agetal = 31
  Case "v"
   agetal = 31
  Case "W"
   agetal = 32
  Case "w"
   agetal = 32
  Case "X"
   agetal = 33
  Case "x"
   agetal = 33
  Case "Y"
   agetal = 34
  Case "y"
   agetal = 34
  Case "Z"
   agetal = 35
  Case "z"
   agetal = 35
  Case " "
   agetal = 36 '(space)
  Case "$"
   agetal = 37
  Case "%"
   agetal = 38
  Case "*"
   agetal = 39
  Case "+"
   agetal = 40
  Case "-"
   agetal = 41
  Case "."
   agetal = 42
  Case "/"
   agetal = 43
  Case ":"
   agetal = 44
End Select

Return agetal

End Sub

Private Sub generator_polynomial(noew As Int) As Int

Dim a3() As Int

'the below is the x-coefficients of the generator polynomials and not the alpha coefficients (i.e alpha converted to x with logg / alogg table)
Select Case noew
  Case  7
    a3 = Array As Int(1, 127, 122, 154, 164, 11, 68, 117) 
  Case  10
    a3 = Array As Int(1, 216, 194, 159, 111, 199, 94, 95, 113, 157, 193) 
  Case  13
    a3 = Array As Int(1, 137, 73, 227, 17, 177, 17, 52, 13, 46, 43, 83, 132, 120)
  Case  15
    a3 = Array As Int(1, 29, 196, 111, 163, 112, 74, 10, 105, 105, 139, 132, 151, 32, 134, 26) 
  Case  16
    a3 = Array As Int(1, 59, 13, 104, 189, 68, 209, 30, 8, 163, 65, 41, 229, 98, 50, 36, 59) 
  Case  17
    a3 = Array As Int(1, 119, 66, 83, 120, 119, 22, 197, 83, 249, 41, 143, 134, 85, 53, 125, 99, 79) 
  Case  18
    a3 = Array As Int(1, 239, 251, 183, 113, 149, 175, 199, 215, 240, 220, 73, 82, 173, 75, 32, 67, 217, 146) 
  Case  20
    a3 = Array As Int(1, 152, 185, 240, 5, 111, 99, 6, 220, 112, 150, 69, 36, 187, 22, 228, 198, 121, 121, 165, 174) 
  Case  22
    a3 = Array As Int(1, 89, 179, 131, 176, 182, 244, 19, 189, 69, 40, 28, 137, 29, 123, 67, 253, 86, 218, 230, 26, 145, 245) 
  Case  24
    a3 = Array As Int(1, 122, 118, 169, 70, 178, 237, 216, 102, 115, 150, 229, 73, 130, 72, 61, 43, 206, 1, 237, 247, 127, 217, 144, 117) 
  Case  26
    a3 = Array As Int(1, 246, 51, 183, 4, 136, 98, 199, 152, 77, 56, 206, 24, 145, 40, 209, 117, 233, 42, 135, 68, 70, 144, 146, 77, 43, 94) 
  Case  28
    a3 = Array As Int(1, 252, 9, 28, 13, 18, 251, 208, 150, 103, 174, 100, 41, 167, 12, 247, 56, 117, 119, 233, 127, 181, 100, 121, 147, 176, 74, 58, 197) 
  Case  30
    a3 = Array As Int(1, 212, 246, 77, 73, 195, 192, 75, 98, 5, 70, 103, 177, 22, 217, 138, 51, 181, 246, 72, 25, 18, 46, 228, 74, 216, 195, 11, 106, 130, 150) 

End Select

For i = 1 To 35
  s4c4(i) = 0      
Next

For i = 1 To noew + 1
  s4c4(i) = a3(i - 1)
Next

End Sub

Private Sub ECC_words                     'sub that calculates the error correction words

   Dim msg_out(2956) As Int
   Dim coef,bollie As Int

   For i =0 To 2955
	  msg_out(i) = 0
   Next  
   For i = 0 To mess_coef_teller - 1
      msg_out(i) = message_coeff(i + 1)
   Next
   For i = 0 To mess_coef_teller - 1
      coef = msg_out(i)
      If coef <> 0 Then
         For j = 0 To no_of_error_words
		    gf_mul_result = gf_mul(s4c4(j + 1), coef)
            bollie = Bit.Xor(msg_out(i + j), gf_mul_result)
            msg_out(i + j) = bollie
         Next
      End If
   Next
   
   For i = 0 To mess_coef_teller - 1
      msg_out(i) = message_coeff(i + 1)
   Next


For i = 1 To no_of_error_words
     s4c24(i) = msg_out(mess_coef_teller - 1 + i)
Next

Dim getal As String
Dim getalle As Int
For i = 1 To no_of_error_words
    getalle = s4c24(i)
    getal = convert_to_binary(getalle)
    Do While sf.stringLength(getal) < 8
      If sf.stringLength(getal) < 8 Then
       getal = "0" & getal
      End If
    Loop 
      ECC_woord = ECC_woord & getal
      q = ECC_woord
Next
  
Return q

End Sub

Private Sub gf_mul(x As Int, y As Int) As Int
   
   If x = 0 Or y = 0 Then
      gf_mul_result = 0
   Else 
     gf_mul_result = alogg(logg(x) + logg(y))
   End If

   Return gf_mul_result   
End Sub

Private Sub place_matrix_data(aaa As Canvas) As Canvas

Dim x1(31335) As Int   'stores the x coordinate of data modules
Dim y1(31335) As Int    'stores the y coordinate of data modules


'The below code determines the x,y coordinates for each of the bits in the complete
'interleaved string and store them in x(i) and y(i) -> rows and columns

draw_qr      'call procedure to draw the QR matrix - not populated but selected mask pattern will be added

Dim ry,col1,col2,rgt,teller,up,a3,i As Int

ry = qr_size                     'we start on excel row qr size +1
col1 = qr_size                   'we start first column on excel column qr size +1
col2 = col1 - 1              'we do two columns at a time when packing bits - thus column y is used along with y+1, etc
rgt = 1                      'marker for the righthand/lefthand column of the two columns that we are currently working with
teller = 1                   'keeps count of the number of valid cells that can take a bit (the count will exclude format info, version info and all patterns)
up = 1                       'keep track of the direction that we are going ---> up or down


Do While teller <> max_mod + 1 
    If rgt = 1 And up = 1 Then        'in the right column of the two columns and going up
      a3 = s5cij(ry, col1)
      If a3 <> 9 And a3 <> 10 And ry > 0 Then     'it is a cell that can accommodate a bit
        x1(teller) = ry
        y1(teller) = col1
        rgt = 0                       'next bit to go in the left column
        teller = teller + 1
      Else
        rgt = 0
      End If
	
    Else If rgt = 0 And up = 1 Then    'in the left column of the two columns and going up
       a3 = s5cij(ry, col2)
       If a3 <> 9 And a3 <> 10 And ry > 0 Then
         x1(teller) = ry
         y1(teller) = col2
         rgt = 1                      'next bit to go in the right column
         teller = teller + 1
         ry = ry - 1                  'go up 1 row
       Else
         rgt = 1
         ry = ry - 1
        End If
    
    Else If rgt = 1 And up = 0 Then    'in the right column of the two columns and going down
       a3 = s5cij(ry, col1)
       If a3 <> 9 And a3 <> 10 And ry < qr_size + 1 Then    '***** qr_size + 2
         x1(teller) = ry
         y1(teller) = col1
         rgt = 0
         teller = teller + 1
       Else
         rgt = 0
       End If
    
    Else If rgt = 0 And up = 0 Then   'in the left column of the two columns and going down
       a3 = s5cij(ry, col2)
       If a3 <> 9 And a3 <> 10 And ry < qr_size + 1 Then                '***** qr_size + 2
         x1(teller) = ry
         y1(teller) = col2
         rgt = 1
         teller = teller + 1
         ry = ry + 1             'go down 1 row
       Else
         rgt = 1
         ry = ry + 1
       End If
    End If
    
    If ry = 0 And col1 > 1 And up = 1 And rgt = 1 Then
      ry = 1
      rgt = 1
      up = 0
      col1 = col1 - 2
      If col1 = 7 Then col1 = 6    'the vertical timing pattern does not take bits - so skip this column
      col2 = col1 - 1
    Else If ry = qr_size + 1 And col1 > 1 And up = 0 And rgt = 1 Then  '******* qr_size + 2
      ry = qr_size
      rgt = 1
      up = 1
      col1 = col1 - 2
      If col1 = 7 Then col1 = 6
      col2 = col1 - 1
    End If
Loop    'we now have the x,y coordinates of all the data modules and it is stored in arrays x(i) and y(i)

'The code that follows fill the matix from the string of data bits

If sf.stringLength(anew) < max_mod Then    'if the string length is less than the required length then pad it with trailing zeros
  Do While sf.stringLength(anew) <> max_mod
    anew = anew & "1"   'Changed from 0 to 1 on 28 March 2014
  Loop 
End If

teller = 1                    'keep track of the bits to place according to x(teller) and y(teller)

Dim bitt As Int

Do While teller <> max_mod + 1                             'place the black/white modules in the matrix
 bitt = sf.Val(sf.Mid(anew, teller, 1))  'get a bit at a time

 If s5cij(x1(teller), y1(teller)) = 0 And bitt = 0 Then
   s5cij(x1(teller), y1(teller)) = 10   'decide what color to make the module based on the bit value and the mask bit in that specific module -> 1 = black and 2 = white
 Else If s5cij(x1(teller), y1(teller)) = 0 And bitt = 1 Then
     s5cij(x1(teller), y1(teller)) = 9

 Else If s5cij(x1(teller), y1(teller)) = 1 And bitt = 0 Then
    s5cij(x1(teller), y1(teller)) = 9
 Else If s5cij(x1(teller), y1(teller)) = 1 And bitt = 1 Then
     s5cij(x1(teller), y1(teller)) = 10
 End If
 teller = teller + 1
Loop    'if teller reaches max_mod + 1 then we have placed all the bits in the string
                            'inside the matrix


'*********************************************************************************************************************************************************
'Make the 3 x finding patterns square (= 15 in their 1 bit cells)
'*********************************************************************************************************************************************************
Dim fp() As Int
fp = Array As Int(1, 1, 1, 1, 1, 1, 1, _
                  1, 0, 0, 0, 0, 0, 1, _
                  1, 0, 1, 1, 1, 0, 1, _
                  1, 0, 1, 1, 1, 0, 1, _
                  1, 0, 1, 1, 1, 0, 1, _
                  1, 0, 0, 0, 0, 0, 1, _
                  1, 1, 1, 1, 1, 1, 1)
Dim teller As Int
teller = 1              'put down the 3 finding patterns
For i = 1 To 7
  For j = 1 To 7
    If fp(teller - 1) = 1 Then     'fp() stores the patterns of the finding pattern
	  If teller = 17 Or teller = 18 Or teller = 19 Or _    'the black middle row of each finding pattern
	     teller = 24 Or teller = 25 Or teller = 26 Or _
		 teller = 31 Or teller = 32 Or teller = 33 Then
	     s5cij(i, j) = 16         'it will become a black square
	     s5cij(i, qr_size - 7 + j) = 16                    'the inner 9 pixels of the finding patterns
	     s5cij(qr_size - 7 + i, j) = 16
	     teller = teller + 1
	  Else
	     s5cij(i, j) = 15         'it will become a black square - the outer ring of the finding pattern
	     s5cij(i, qr_size - 7 + j) = 15
	     s5cij(qr_size - 7 + i, j) = 15
	     teller = teller + 1
	  End If   
    Else
      s5cij(i, j) = 9  'it will become a white square
      s5cij(i, qr_size - 7 + j) = 9
      s5cij(qr_size - 7 + i, j) = 9
      teller = teller + 1
    End If
  Next 
Next 

teken1(aaa)

Return aaa
							
End Sub

Private Sub draw_qr

'the pattern of a finding pattern
Dim fp() As Int
fp = Array As Int(1, 1, 1, 1, 1, 1, 1, _
                  1, 0, 0, 0, 0, 0, 1, _
                  1, 0, 1, 1, 1, 0, 1, _
                  1, 0, 1, 1, 1, 0, 1, _
                  1, 0, 1, 1, 1, 0, 1, _
                  1, 0, 0, 0, 0, 0, 1, _
                  1, 1, 1, 1, 1, 1, 1)
'the pattern of an alignment pattern
Dim ap() As Int
ap = Array As Int(1, 1, 1, 1, 1, _
                  1, 0, 0, 0, 1, _
                  1, 0, 1, 0, 1, _
                  1, 0, 0, 0, 1, _
                  1, 1, 1, 1, 1)

Dim apx(50)   'store x coordinates of alignment pattern central modules
Dim apy(50)   'store y coordinates of alignment pattern central modules
Dim co_x(8)
Dim co_y(8)

'Log(maskp)

If maskp = 0 Then
  For i = 1 To qr_size                  'load mask pattern 0 in the whole matrix
    For j = 1 To qr_size                'we will null the mask in all format/version modules as we place these modules
      s5cij(i, j) = ((i - 1) + (j - 1)) Mod 2
    Next 
  Next 
End If

If maskp = 1 Then
  For i = 1 To qr_size                  'load mask pattern 1 in the whole matrix
    For j = 1 To qr_size                'we will null the mask in all format/version modules as we place these modules
      s5cij(i, j) = (i - 1) Mod 2
    Next 
  Next 
End If

If maskp = 2 Then
  For i = 1 To qr_size                  'load mask pattern 2 in the whole matrix
    For j = 1 To qr_size                'we will null the mask in all format/version modules as we place these modules
      s5cij(i, j) = (j - 1) Mod 3
      If s5cij(i, j) > 1 Then s5cij(i, j) = 1
    Next 
  Next 
End If

If maskp = 3 Then
  For i = 1 To qr_size                  'load mask pattern 3 in the whole matrix
    For j = 1 To qr_size                'we will null the mask in all format/version modules as we place these modules
      s5cij(i, j) = ((i - 1) + (j - 1)) Mod 3
      If s5cij(i, j) > 1 Then s5cij(i, j) = 1
    Next 
  Next 
End If

If maskp = 4 Then
  For i = 1 To qr_size                  'load mask pattern 4 in the whole matrix
    For j = 1 To qr_size                'we will null the mask in all format/version modules as we place these modules
      s5cij(i, j) = ((Floor((i - 1) / 2  )) + (Floor((j - 1) / 3))) Mod 2
    Next 
  Next 
End If

If maskp = 5 Then
  For i = 1 To qr_size                  'load mask pattern 5 in the whole matrix
    For j = 1 To qr_size                'we will null the mask in all format/version modules as we place these modules
      s5cij(i, j) = (((i - 1) * (j - 1)) Mod 2) + (((i - 1) * (j - 1)) Mod 3)
      If s5cij(i, j) > 1 Then s5cij(i, j) = 1
    Next 
  Next 
End If

If maskp = 6 Then
  For i = 1 To qr_size                  'load mask pattern 6 in the whole matrix
    For j = 1 To qr_size                'we will null the mask in all format/version modules as we place these modules
      s5cij(i, j) = ((((i - 1) * (j - 1)) Mod 2) + (((i - 1) * (j - 1)) Mod 3)) Mod 2
    Next 
  Next 
End If

If maskp = 7 Then
  For i = 1 To qr_size                  'load mask pattern 7 in the whole matrix
    For j = 1 To qr_size                'we will null the mask in all format/version modules as we place these modules
      s5cij(i, j) = ((((i - 1) + (j - 1)) Mod 2) + (((i - 1) * (j - 1)) Mod 3)) Mod 2
    Next 
  Next 
End If
Dim teller As Int
teller = 1              'put down the 3 finding patterns
For i = 1 To 7
  For j = 1 To 7
    If fp(teller - 1) = 1 Then     'fp() stores the patterns of the finding pattern
      s5cij(i, j) = 10         'it will become a white square
      s5cij(i, qr_size - 7 + j) = 10
      s5cij(qr_size - 7 + i, j) = 10
      teller = teller + 1
    Else
      s5cij(i, j) = 9  'it will become a black square
      s5cij(i, qr_size - 7 + j) = 9
      s5cij(qr_size - 7 + i, j) = 9
      teller = teller + 1
    End If
  Next 
Next 
For j = 9 To qr_size - 7    'place horizontal timing pattern
  If j Mod 2 = 1 Then
    s5cij(7, j) = 10
  Else
    s5cij(7, j) = 9
  End If
Next 
For i = 9 To qr_size - 7         'place vertical timing pattern
  If i Mod 2 = 1 Then
    s5cij(i, 7) = 10
  Else
    s5cij(i, 7) = 9
  End If
Next
s5cij(qr_size - 7, 9) = 10  'place reserved bit to the right and top of bottom left finding pattern

Dim vi As String

Select Case version_no
  Case 7
     vi = "001010010011111000"
  Case 8
     vi = "001111011010000100"
   Case 9
     vi = "100110010101100100"
   Case 10
     vi = "110010110010010100"
   Case 11
     vi = "011011111101110100"
   Case 12
     vi = "010001101110001100"
   Case 13
     vi = "111000100001101100"
   Case 14
     vi = "101100000110011100"
   Case 15
     vi = "000101001001111100"
   Case 16
     vi = "000111101101000010"
   Case 17
     vi = "101110100010100010"
   Case 18
     vi = "111010000101010010"
   Case 19
     vi = "010011001010110010"
   Case 20
     vi = "011001011001001010"
   Case 21
     vi = "110000010110101010"
   Case 22
     vi = "100100110001011010"
   Case 23
     vi = "001101111110111010"
   Case 24
     vi = "001000110111000110"
   Case 25
     vi = "100001111000100110"
   Case 26
     vi = "110101011111010110"
   Case 27
     vi = "011100010000110110"
   Case 28
     vi = "010110000011001110"
   Case 29
     vi = "111111001100101110"
   Case 30
     vi = "101011101011011110"
   Case 31
     vi = "000010100100111110"
   Case 32
     vi = "101010111001000001"
   Case 33
     vi = "000011110110100001"
   Case 34
     vi = "010111010001010001"
   Case 35
     vi = "111110011110110001"
   Case 36
     vi = "110100001101001001"
   Case 37
     vi = "011101000010101001"
   Case 38
     vi = "001001100101011001"
   Case 39
     vi = "100000101010111001"
   Case 40
     vi = "100101100011000101"
 End Select

If version_no >= 7 Then
    teller = 1         'put version information to left of top right finding pattern
    For i = 1 To 6
      For j = 1 To 3
        If sf.Mid(vi, teller, 1) = "1" Then
          s5cij(i, qr_size - 11 + j) = 10
          teller = teller + 1
        Else
          s5cij(i, qr_size - 11 + j) = 9
          teller = teller + 1
        End If
      Next 
    Next 
    teller = 1        'put version information above bottom left finding pattern
    For j = 1 To 6
      For i = 1 To 3
        If sf.Mid(vi, teller, 1) = "1" Then
          s5cij(qr_size - 11 + i, j) = 10
           teller = teller + 1
        Else
          s5cij(qr_size - 11 + i, j) = 9
           teller = teller + 1
        End If
      Next 
    Next 
End If

'nullify horizontal mask patterns around alignment patterns
For j = 1 To 8
  s5cij(8, j) = 9
  s5cij(qr_size - 7, j) = 9
  s5cij(8, qr_size - 7 + j) = 9
Next 

'nullify vertical mask patterns around alignment patterns
For i = 1 To 8
  s5cij(i, 8) = 9
  s5cij(i, qr_size - 7) = 9
  s5cij(qr_size - 7 + i, 8) = 9
Next

'nullify horizontal mask patterns around where format info goes
For j = 1 To 9
  If s5cij(9, j) <> 10 Then s5cij(9, j) = 9 
  If s5cij(9, qr_size - 8 + j) <> 10 Then s5cij(9, qr_size - 8 + j) = 9
Next

'nullify vertical mask patterns around alignment patterns
For i = 1 To 8
  If s5cij(i, 9) <> 10 Then s5cij(i, 9) = 9
  If s5cij(qr_size - 8 + i, 9) <> 10 Then s5cij(qr_size - 8 + i, 9) = 9
Next

'now place the format information
Dim tipe As String
Select Case error_level
	Case "L"
		If maskp = 0 Then tipe = "111011111000100"
		If maskp = 1 Then tipe = "111001011110011"
		If maskp = 2 Then tipe = "111110110101010"
		If maskp = 3 Then tipe = "111100010011101"
		If maskp = 4 Then tipe = "110011000101111"
		If maskp = 5 Then tipe = "110001100011000"
		If maskp = 6 Then tipe = "110110001000001"
		If maskp = 7 Then tipe = "110100101110110"
Case "M"
		If maskp = 0 Then tipe = "101010000010010"
		If maskp = 1 Then tipe = "101000100100101"
		If maskp = 2 Then tipe = "101111001111100"
		If maskp = 3 Then tipe = "101101101001011"
		If maskp = 4 Then tipe = "100010111111001"
		If maskp = 5 Then tipe = "100000011001110"
		If maskp = 6 Then tipe = "100111110010111"
		If maskp = 7 Then tipe = "100101010100000"
Case "Q"
		If maskp = 0 Then tipe = "011010101011111"
		If maskp = 1 Then tipe = "011000001101000"
		If maskp = 2 Then tipe = "011111100110001"
		If maskp = 3 Then tipe = "011101000000110"
		If maskp = 4 Then tipe = "010010010110100"
		If maskp = 5 Then tipe = "010000110000011"
		If maskp = 6 Then tipe = "010111011011010"
		If maskp = 7 Then tipe = "010101111101101"
Case "H"
		If maskp = 0 Then tipe = "001011010001001"
		If maskp = 1 Then tipe = "001001110111110"
		If maskp = 2 Then tipe = "001110011100111"
		If maskp = 3 Then tipe = "001100111010000"
		If maskp = 4 Then tipe = "000011101100010"
		If maskp = 5 Then tipe = "000001001010101"
		If maskp = 6 Then tipe = "000110100001100"
		If maskp = 7 Then tipe = "000100000111011"
End Select

teller = 1    'place horizontal format info
For j = 1 To 15
  If sf.Mid(tipe, j, 1) = "1" Then
    s5cij(9, teller) = 10
  Else
    s5cij(9, teller) = 9
  End If
  teller = teller + 1
  If teller = 7 Then teller = teller + 1
  If teller = 9 Then teller = qr_size - 7   'was 7
Next 
teller = qr_size  'place vertical format info
For i = 1 To 15
  If sf.Mid(tipe, i, 1) = "1" Then
    s5cij(teller, 9) = 10
  Else
    s5cij(teller, 9) = 9
  End If
  teller = teller - 1
  If teller = qr_size - 7 Then teller = 9
  If teller = 7 Then teller = 6
Next

Dim k As Int
For k = 1 To 7
  co_x(k) = 0
  co_y(k) = 0
Next 

If version_no>1 Then
  co_x(1) = ver(version_no,57)
  co_x(2) = ver(version_no,58)
  co_x(3) = ver(version_no,59)
  co_x(4) = ver(version_no,60)
  co_x(5) = ver(version_no,61)
  co_x(6) = ver(version_no,62)
  co_x(7) = ver(version_no,63)
  co_y(1) = ver(version_no,57)
  co_y(2) = ver(version_no,58)
  co_y(3) = ver(version_no,59)
  co_y(4) = ver(version_no,60)
  co_y(5) = ver(version_no,61)
  co_y(6) = ver(version_no,62)
  co_y(7) = ver(version_no,63)  
End If

Dim flag,last As Int
'find coordinates of alignment patterns
If version_no > 1 Then  'only required for version 2 upwards - no alignment patterns in version 1
  flag = 0
  For k = 1 To 7
    If co_x(k) = 0 Then   'And flag = 0
      last = co_x(k - 1)
      Exit
    Else
      last = co_x(k)
    End If
  Next 
End If

teller = 1
For i = 1 To 7
  For j = 1 To 7
    apx(teller) = co_x(i)
    apy(teller) = co_y(j)
    teller = teller + 1
  Next 
Next 

'******************************************************************
Dim first As Int
first = 6    'this is always the first x or y cooridinate of one of the alignment patterns

'got last number other than zero stored in "last"

'put down the alignment patterns
flag = 0
For i = 1 To 49
  teller = 1
  If apx(i) = 0 Or apy(i) = 0 Then flag = 1
  If apx(i) = first And apy(i) = first Then flag = 1   'exclude this combination - occupied by finding pattern i.e coordinate 6,6
  If apx(i) = first And apy(i) = last Then flag = 1    'exclude this combination - occupied by finding pattern i.e coordinate last,6
  If apx(i) = last And apy(i) = first Then flag = 1    'exclude this combination - occupied by finding pattern i.e coordinate 6,last
        If flag = 0 Then                               'a valid x,y position for an alignment pattern
          For k = apx(i) To apx(i) + 4
            For l = apy(i) To apy(i) + 4
              If ap(teller - 1) = 1 Then
                s5cij(k-1, l-1) = 10
                teller = teller + 1
              Else
                s5cij(k-1, l-1) = 9
                teller = teller + 1
              End If
            Next 
          Next
       Else
          flag = 0
       End If
Next

'teken1    'gotcha

End Sub

Private Sub select_block

max_mod = ver(version_no,12)
qr_size = ver(version_no,1)

Select Case error_level
Case "L"
	max_data_bits = ver(version_no,20)
	block1 = ver(version_no,24)
	block2 = ver(version_no,28)
	dw1 = ver(version_no,26)
	dw2 = ver(version_no,30)
	ew1 = ver(version_no,27)
	ew2 = ver(version_no,31)
	tel2 = ver(version_no,76)

Case  "M" 
	max_data_bits = ver(version_no,21)
	block1 = ver(version_no,32)
	block2 = ver(version_no,36)
	dw1 = ver(version_no,34)
	dw2 = ver(version_no,38)
	ew1 = ver(version_no,35)
	ew2 = ver(version_no,39)	
	tel2 = ver(version_no,77)

Case  "Q" 
	max_data_bits = ver(version_no,22)	
	block1 = ver(version_no,40)
	block2 = ver(version_no,44)
	dw1 = ver(version_no,42)
	dw2 = ver(version_no,46)
	ew1 = ver(version_no,43)
	ew2 = ver(version_no,47)		
	tel2 = ver(version_no,78)

Case "H" 
	max_data_bits = ver(version_no,23)
	block1 = ver(version_no,48)
	block2 = ver(version_no,52)
	dw1 = ver(version_no,50)
	dw2 = ver(version_no,54)
	ew1 = ver(version_no,51)
	ew2 = ver(version_no,55)		
	tel2 = ver(version_no,79)	
	
End Select

End Sub

Private Sub determine_max_len

Dim Comp As Int 

Select Case error_level
	Case "L":Comp=64
	Case "M":Comp=65
	Case "Q":Comp=66
	Case "H":Comp=67
End Select

If sf.stringLength(dat) >= 0 Then version_no = 1

For i=1 To 39
	If sf.stringLength(dat) > ver(i,Comp) Then version_no = i+1
Next

GetMaxLen 

End Sub

'Store the QR Code code as a ver(25, file in the pictures folder (File.DirRootExternal, "pictures/Aztec.ver(25,")
'and load it into ImageView1 
Private Sub teken1(d As Canvas) As Canvas

Dim sizx, sizy As Double
sizx = 1
sizy = 1

For i =  1 To qr_size
  For j = 1 To qr_size
    If s5cij(i,j) = 10  Then  'Or s5cij(i,j) = 1 Then
        d.DrawRect(sizx,sizy,module_size,module_size,fore_color,True,1)  
	Else If s5cij(i,j) = 9  Then 'Or s5cij(i,j) = 0 Then
        d.DrawRect(sizx,sizy,module_size,module_size,back_color,True,1)	
	Else                              'only if there is an error in the code that populates the QR code matrix i.e in array "s5cij"
        d.DrawRect(sizx,sizy,module_size,module_size,fore_color,True,1)			
	End If	
	sizx = sizx + module_size
  Next
  sizx = 1
  sizy = sizy + module_size                                         
Next 

Return d

End Sub

Sub GetMaxLen

If error_level = "L" And tipe  = "8-bit-Byte" Then maxlen = ver(version_no,64)	
If error_level = "M" And tipe  = "8-bit-Byte" Then maxlen = ver(version_no,65)	
If error_level = "Q" And tipe  = "8-bit-Byte" Then maxlen = ver(version_no,66)	
If error_level = "H" And tipe  = "8-bit-Byte" Then maxlen = ver(version_no,67)	
If error_level = "L" And tipe  = "Numeric" Then maxlen = ver(version_no,68)	
If error_level = "M" And tipe  = "Numeric" Then maxlen = ver(version_no,69)	
If error_level = "Q" And tipe  = "Numeric" Then maxlen = ver(version_no,70)	
If error_level = "H" And tipe  = "Numeric" Then maxlen = ver(version_no,71)	
If error_level = "L" And tipe  = "Alphanumeric" Then maxlen = ver(version_no,72)	
If error_level = "M" And tipe  = "Alphanumeric" Then maxlen = ver(version_no,73)	
If error_level = "Q" And tipe  = "Alphanumeric" Then maxlen = ver(version_no,74)	
If error_level = "H" And tipe  = "Alphanumeric" Then maxlen = ver(version_no,75)	

End Sub

Sub Add2Array
	
 ver1 = Array As Int (1,21,441,0,30,1,0,0,0,10,192,233,208,208,0,26,7,10,13,17,152,128,104,72,1,26,19,7,0,0,0,0,1,26,16,10,0,0,0,0,1,26,13,13,0,0,0,0,1,26,9,17,0,0,0,0,0,0,0,0,0,0,0,0,17,14,11,7,40,33,26,16,24,19,15,9,19,16,13,9)
 ver2 = Array As Int (2,25,625,0,30,1,1,0,25,18,192,266,359,352,7,44,10,16,22,28,272,224,176,128,1,44,34,10,0,0,0,0,1,44,28,16,0,0,0,0,1,44,22,22,0,0,0,0,1,44,16,28,0,0,0,0,1,6,18,0,0,0,0,0,32,26,20,14,76,62,47,33,46,37,28,19,34,28,22,16)
 ver3 = Array As Int (3,29,841,0,30,1,1,0,25,26,192,274,567,560,7,70,15,26,36,44,440,352,272,208,1,70,55,15,0,0,0,0,1,70,44,26,0,0,0,0,2,35,17,18,0,0,0,0,2,35,13,22,0,0,0,0,1,6,22,0,0,0,0,0,53,42,32,24,126,100,76,57,76,60,46,34,55,44,17,13)
 ver4 = Array As Int (4,33,1089,0,30,1,1,0,25,34,192,282,807,800,7,100,20,36,52,64,640,512,384,288,1,100,80,20,0,0,0,0,2,50,32,18,0,0,0,0,2,50,24,26,0,0,0,0,4,25,9,16,0,0,0,0,1,6,26,0,0,0,0,0,78,62,46,34,113,89,66,49,113,89,66,49,80,32,24,9)
 ver5 = Array As Int (5,37,1369,0,30,1,1,0,25,42,192,290,1079,1072,7,134,26,48,72,88,864,688,496,368,1,134,108,26,0,0,0,0,2,67,43,24,0,0,0,0,2,33,15,18,2,34,16,18,2,33,11,22,2,34,12,22,1,6,30,0,0,0,0,0,106,84,60,44,153,121,86,63,153,121,86,63,108,43,16,12)
 ver6 = Array As Int (6,41,1681,0,30,1,1,0,25,50,192,298,1383,1376,7,172,36,64,96,112,1088,864,608,480,2,86,68,18,0,0,0,0,4,43,27,16,0,0,0,0,4,43,19,24,0,0,0,0,4,43,15,28,0,0,0,0,1,6,34,0,0,0,0,0,134,106,74,58,194,153,107,83,194,153,107,83,68,27,19,15)
 ver7 = Array As Int (7,45,2025,36,30,1,6,1,150,48,192,457,1568,1568,0,196,40,72,108,130,1248,992,704,528,2,98,78,20,0,0,0,0,4,49,31,18,0,0,0,0,2,32,14,18,4,33,15,18,4,39,13,26,1,40,14,26,6,6,22,38,0,0,0,0,154,122,86,64,223,177,124,92,223,177,124,92,78,31,15,14)
 ver8 = Array As Int (8,49,2401,36,30,1,6,1,150,56,192,465,1936,1936,0,242,48,88,132,156,1552,1232,880,688,2,121,97,24,0,0,0,0,2,60,38,22,2,61,39,22,4,40,18,22,2,41,19,22,4,40,14,26,2,41,15,26,6,6,24,42,0,0,0,0,192,152,108,84,278,220,156,121,278,220,156,121,97,39,19,15)
 ver9 = Array As Int (9,53,2809,36,30,1,6,1,150,64,192,473,2336,2336,0,292,60,110,160,192,1856,1456,1056,800,2,146,116,30,0,0,0,0,3,58,36,22,2,59,37,22,4,36,16,20,4,37,17,20,4,36,12,24,4,37,13,24,6,6,26,46,0,0,0,0,230,180,130,98,551,431,311,234,334,261,188,142,116,37,17,13)
 ver10 = Array As Int (10,57,3249,36,30,1,6,1,150,72,192,481,2768,2768,0,346,72,130,192,224,2192,1728,1232,976,2,86,68,18,2,87,69,18,4,69,43,26,1,70,44,26,6,43,19,24,2,44,20,24,6,43,15,28,2,44,16,28,6,6,28,50,0,0,0,0,271,213,151,119,651,512,363,287,394,310,220,173,69,44,20,16)
 ver11 = Array As Int (11,61,3721,36,30,1,6,1,150,80,192,489,3232,3232,0,404,80,150,224,264,2592,2032,1440,1120,4,101,81,20,0,0,0,0,1,80,50,30,4,81,51,30,4,50,22,28,4,51,23,28,3,36,12,24,8,37,13,24,6,6,30,54,0,0,0,0,321,251,177,137,771,603,426,330,467,365,258,199,81,51,23,13)
 ver12 = Array As Int (12,65,4225,36,30,1,6,1,150,88,192,497,3728,3728,0,466,96,176,260,308,2960,2320,1648,1264,2,116,92,24,2,117,93,24,6,58,36,22,2,59,37,22,4,46,20,26,6,47,21,26,7,42,14,28,4,43,15,28,6,6,32,58,0,0,0,0,367,287,203,155,882,690,488,373,534,418,295,226,93,37,21,15)
 ver13 = Array As Int (13,69,4761,36,30,1,6,1,150,96,192,505,4256,4256,0,532,104,198,288,352,3424,2672,1952,1440,4,133,107,26,0,0,0,0,8,59,37,22,1,60,38,22,8,44,20,24,4,45,21,24,12,33,11,22,4,34,12,22,6,6,34,62,0,0,0,0,425,331,241,177,1021,795,579,426,618,482,351,258,107,38,21,12)
 ver14 = Array As Int (14,73,5329,36,30,1,13,2,325,94,192,678,4651,4648,3,581,120,216,320,384,3688,2920,2088,1576,3,145,115,30,1,146,116,30,4,64,40,24,5,65,41,24,11,36,16,20,5,37,17,20,11,36,12,24,5,37,13,24,13,6,26,46,66,0,0,0,458,362,258,194,1100,870,620,467,666,527,375,282,116,41,17,13)
 ver15 = Array As Int (15,77,5929,36,30,1,13,2,325,102,192,686,5243,5240,3,655,132,240,36,432,4184,3320,4952,1784,5,109,87,22,1,110,88,22,5,65,41,24,5,66,42,24,5,54,24,30,7,55,25,30,11,36,12,24,7,37,13,24,13,6,26,48,70,0,0,0,520,412,292,220,1249,990,702,529,757,599,425,320,88,42,25,13)
 ver16 = Array As Int (16,81,6561,36,30,1,13,2,325,110,192,694,5867,5864,3,733,144,280,408,480,4712,3624,2600,2024,5,122,98,24,1,123,99,24,7,73,45,28,3,74,46,28,15,43,19,24,2,44,20,24,3,45,15,30,13,46,16,30,13,6,26,50,74,0,0,0,586,450,322,250,1407,1081,774,601,853,655,469,364,99,46,20,16)
 ver17 = Array As Int (17,85,7225,36,30,1,13,2,325,118,192,702,6523,6520,3,815,168,308,448,532,5176,4056,2936,2264,1,135,107,28,5,136,108,28,10,74,46,28,1,75,47,14,1,50,22,28,15,51,23,28,2,42,14,28,17,43,15,28,13,6,30,54,78,0,0,0,644,504,364,280,1547,1211,875,673,937,733,530,407,108,47,23,15)
 ver18 = Array As Int (18,89,7921,36,30,1,13,2,325,126,192,710,7211,7208,3,901,180,338,504,588,5768,4504,3176,2504,5,150,120,30,1,151,121,30,9,69,43,26,4,70,44,26,17,50,22,28,1,51,23,28,2,42,14,28,19,43,15,28,13,6,30,56,82,0,0,0,718,560,394,310,1724,1345,947,745,1045,815,573,451,121,44,23,15)
 ver19 = Array As Int (19,93,8649,36,30,1,13,2,325,134,192,718,7931,7928,3,991,196,364,546,650,6360,5016,3560,2728,3,141,113,28,4,142,114,28,3,70,44,26,11,71,45,26,17,47,21,26,4,48,22,26,9,39,13,26,16,40,14,26,13,6,30,58,86,0,0,0,792,624,442,338,192,1499,1062,812,1152,908,643,492,114,45,22,14)
 ver20 = Array As Int (20,97,9409,36,30,1,13,2,325,142,192,726,8683,8680,3,1085,224,416,600,700,6888,5352,3880,3080,3,135,107,28,5,136,108,28,3,67,41,26,13,68,42,26,15,54,24,30,5,55,25,30,15,43,15,28,10,44,16,28,13,6,34,62,90,0,0,0,858,666,482,382,2060,1599,1158,918,1248,969,701,556,108,42,25,16)
 ver21 = Array As Int (21,101,10201,36,30,1,22,3,550,140,192,949,9252,9248,4,1156,224,442,644,750,7456,5712,4096,3248,4,144,116,28,4,145,117,28,17,68,42,26,0,0,0,0,17,50,22,28,6,51,23,28,19,46,16,30,6,47,17,30,22,6,28,50,72,94,0,0,929,711,509,403,2231,1707,1223,968,1351,1034,741,586,117,42,23,17)
 ver22 = Array As Int (22,105,11025,36,30,1,22,3,550,148,192,957,10068,10064,4,1258,252,476,690,816,8048,6256,4544,3536,2,139,111,28,7,140,112,28,17,74,46,28,0,0,0,0,7,54,24,30,16,55,25,30,34,37,13,24,0,0,0,0,22,6,26,50,74,98,0,0,1003,779,565,439,2408,1871,1357,1055,1459,1133,822,639,112,46,25,13)
 ver23 = Array As Int (23,109,11881,36,30,1,22,3,550,156,192,965,10916,10912,4,1364,270,504,750,900,8752,6880,4912,3712,4,151,121,30,5,152,122,30,4,75,47,28,14,76,48,28,11,54,24,30,14,55,25,30,16,45,15,30,14,46,16,30,22,6,30,54,78,102,0,0,1091,857,611,461,2619,2058,1467,1107,1587,1247,88,671,122,48,25,16)
 ver24 = Array As Int (24,113,12769,36,30,1,22,3,550,164,192,973,11796,11792,4,1474,300,560,810,960,9392,7312,5312,4112,6,147,117,30,4,148,118,30,6,73,45,28,14,74,46,28,11,54,24,30,16,55,25,30,30,46,16,30,2,47,17,30,22,6,28,54,80,106,0,0,1171,911,661,511,2811,2187,1587,1227,1703,1325,962,743,118,46,25,17)
 ver25 = Array As Int (25,117,13689,36,30,1,22,3,550,172,192,981,12708,12704,4,1588,312,588,870,1050,10208,8000,5744,4304,8,132,106,26,4,133,107,26,8,75,47,28,13,76,48,28,7,54,24,30,22,55,25,30,22,45,15,30,13,46,16,30,22,6,32,58,84,110,0,0,1273,997,715,535,3056,2394,1717,1285,1852,1450,1040,778,107,48,25,16)
 ver26 = Array As Int (26,121,14641,36,30,1,22,3,550,180,192,989,13652,13648,4,1706,336,644,952,1110,10960,8496,6032,4768,10,142,114,28,2,143,115,28,19,74,46,28,4,75,47,28,28,50,22,28,6,51,23,28,33,46,16,30,4,47,17,30,22,6,30,58,86,114,0,0,1367,1059,751,593,3282,2543,1803,1424,1989,1541,1093,863,115,47,23,17)
 ver27 = Array As Int (27,125,15625,36,30,1,22,3,550,188,192,997,14628,14624,4,1828,360,700,1020,1200,11744,9024,6464,5024,8,152,122,30,4,153,123,30,22,73,45,28,3,74,46,28,8,53,23,30,26,54,24,30,12,45,15,30,28,26,16,30,22,6,34,62,90,118,0,0,1465,1125,805,625,3516,2700,1932,1500,2131,1636,1171,909,123,46,24,16)
 ver28 = Array As Int (28,129,16641,36,30,1,33,4,825,186,192,1270,15371,15368,3,1921,390,728,1050,1260,12248,9544,6968,5288,3,147,117,30,10,148,118,30,3,73,45,28,23,74,46,28,4,54,24,30,31,55,25,30,11,45,15,30,31,46,16,30,33,6,26,50,74,98,122,0,1528,1190,868,658,3668,2856,2084,1580,2222,1731,1262,957,118,46,25,16)
 ver29 = Array As Int (29,133,17689,36,30,1,33,4,825,194,192,1278,16411,16408,3,2051,420,784,1140,1350,13048,10136,7288,5608,7,146,116,30,7,147,117,30,21,73,45,28,7,74,46,28,1,53,23,30,37,54,24,30,19,45,15,30,26,46,16,30,33,6,30,54,78,102,126,0,1628,1264,908,698,398,3034,2180,1676,2368,1838,1321,1015,117,46,24,16)
 ver30 = Array As Int (30,137,18769,36,30,1,33,4,825,202,192,1286,17483,17480,3,2185,450,812,1200,1440,13880,10984,7880,5960,5,145,115,30,10,146,116,30,19,75,47,28,10,76,48,28,15,54,24,30,25,55,25,30,23,45,15,30,25,46,16,30,33,6,26,52,78,104,130,0,1732,1370,982,742,4157,3288,2357,1781,2519,1993,1428,1079,116,48,25,16)
 ver31 = Array As Int (31,141,19881,36,30,1,33,4,825,210,192,1294,18587,18584,3,2323,480,868,1290,1530,14744,11640,8264,6344,13,145,115,30,3,146,116,30,2,74,46,28,29,75,47,28,42,54,24,30,1,55,25,30,23,45,15,30,28,46,16,30,33,6,30,56,82,108,134,0,1840,1452,1030,790,4416,3485,2472,1896,2676,2112,1498,1149,116,47,25,16)
 ver32 = Array As Int (32,145,21025,36,30,1,33,4,825,218,192,1302,19723,19720,3,2465,510,924,1350,1620,15640,12328,8920,6760,17,145,115,30,0,0,0,0,10,74,46,28,23,75,47,28,10,54,24,30,35,55,25,30,19,45,15,30,35,46,16,30,33,6,34,60,86,112,138,0,1952,1538,1112,842,4685,3692,2669,2021,2839,2237,1617,1225,115,47,25,16)
 ver33 = Array As Int (33,149,22201,36,30,1,33,4,825,226,192,1310,20891,20888,3,2611,540,980,1440,1710,16568,13048,9368,7208,17,145,115,30,1,146,116,30,14,74,46,28,21,75,47,28,29,54,24,30,19,55,25,30,11,45,15,30,46,46,16,30,33,6,30,58,86,114,142,0,2068,1628,1168,898,4964,3908,2804,2156,3008,2368,1699,1306,116,47,25,16)
 ver34 = Array As Int (34,153,23409,36,30,1,33,4,825,234,192,1318,22091,22088,3,2761,570,1036,1530,1800,17528,13800,9848,7688,13,145,115,30,6,146,116,30,14,74,46,28,23,75,47,28,44,54,24,30,7,55,25,30,59,46,16,30,1,47,17,30,33,6,34,62,90,118,146,0,2188,1722,1228,958,5252,4133,2948,2300,3182,2505,1786,1393,116,47,25,17)
 ver35 = Array As Int (35,157,24649,36,30,1,46,5,1150,232,192,1641,23008,23008,0,2876,570,1064,1590,1890,18448,14496,10288,7888,12,151,121,30,7,152,122,30,12,75,47,28,26,76,48,28,39,54,24,30,14,55,25,30,22,45,15,30,41,46,16,30,46,6,30,54,78,102,126,150,2303,1809,1283,983,5528,4342,3080,2360,3350,2631,1866,1430,122,48,25,16)
 ver36 = Array As Int (36,161,25921,36,30,1,46,5,1150,240,192,1649,24272,24272,0,3034,600,1120,1680,1980,19472,15312,10832,8432,6,151,121,30,14,152,122,30,6,75,47,28,34,76,48,28,46,54,24,30,10,55,25,30,2,45,15,30,64,46,16,30,46,6,24,50,76,102,128,154,2431,1911,1351,1051,5835,4587,3243,2523,3536,2779,1965,1529,122,48,25,16)
 ver37 = Array As Int (37,165,27225,36,30,1,46,5,1150,248,192,1657,25568,25568,0,3196,630,1204,1770,2100,20528,15936,11408,8768,17,152,122,30,4,153,123,30,29,74,46,28,14,75,47,28,49,54,24,30,10,55,25,30,24,45,15,30,46,46,16,30,46,6,28,54,80,106,132,158,2563,1989,1423,1093,6152,4774,3416,2624,3728,2893,2070,1590,123,47,25,16)
 ver38 = Array As Int (38,169,28561,36,30,1,46,5,1150,256,192,1665,26896,26896,0,3362,660,1260,1860,2220,21616,16816,12016,9136,4,152,122,30,18,153,123,30,13,74,46,28,32,75,47,28,48,54,24,30,14,55,25,30,42,45,15,30,32,46,16,30,46,6,32,58,84,110,136,162,2699,2099,1499,1139,6478,5038,3598,2734,3926,3053,2180,1657,123,47,25,16)
 ver39 = Array As Int (39,173,29929,36,30,1,46,5,1150,264,192,1673,28256,28256,0,3532,720,1316,1950,2310,22496,17728,12656,9776,20,147,117,30,4,148,118,30,40,75,47,28,7,76,48,28,43,54,24,30,22,55,25,30,10,45,15,30,67,46,16,30,46,6,26,54,82,110,138,166,2809,2213,1579,1219,6742,5312,3790,2926,4086,3219,2297,1773,118,48,25,16)
 ver40 = Array As Int (40,177,31329,36,30,1,46,5,1150,272,192,1681,29648,29648,0,3706,750,1372,2040,2430,23648,18672,13328,10208,19,148,118,30,6,149,119,30,18,75,47,28,31,76,48,28,34,54,24,30,34,55,25,30,20,45,15,30,61,46,16,30,46,6,30,58,86,114,142,170,2953,2331,1663,1273,7088,5595,3992,3056,4295,3390,2419,1851,119,48,25,16)	
	
Add2Ver(1,ver1)
Add2Ver(2,ver2)
Add2Ver(3,ver3)
Add2Ver(4,ver4)
Add2Ver(5,ver5)
Add2Ver(6,ver6)
Add2Ver(7,ver7)
Add2Ver(8,ver8)
Add2Ver(9,ver9)
Add2Ver(10,ver10)
Add2Ver(11,ver11)
Add2Ver(12,ver12)
Add2Ver(13,ver13)
Add2Ver(14,ver14)
Add2Ver(15,ver15)
Add2Ver(16,ver16)
Add2Ver(17,ver17)
Add2Ver(18,ver18)
Add2Ver(19,ver19)
Add2Ver(20,ver20)
Add2Ver(21,ver21)
Add2Ver(22,ver22)
Add2Ver(23,ver23)
Add2Ver(24,ver24)
Add2Ver(25,ver25)
Add2Ver(26,ver26)
Add2Ver(27,ver27)
Add2Ver(28,ver28)
Add2Ver(29,ver29)
Add2Ver(30,ver30)
Add2Ver(31,ver31)
Add2Ver(32,ver32)
Add2Ver(33,ver33)
Add2Ver(34,ver34)
Add2Ver(35,ver35)
Add2Ver(36,ver36)
Add2Ver(37,ver37)
Add2Ver(38,ver38)
Add2Ver(39,ver39)
Add2Ver(40,ver40)
End Sub

Sub Add2Ver(Row As Int, Arr() As Int) 
	
  Dim RowLength As Int =Arr.Length 
  For c = 0 To RowLength - 1
     ver(Row, c) = Arr(c)
  Next
  
End Sub