﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.1
@EndOfDesignText@
Sub Process_Globals
	Private fx As JFX
	Private xui As XUI
	Private btnConnect As Button
	Private btnSearch As Button
	
	Private txtLog As TextArea
	
	Private bt As Bluetooth
	Private astream As AsyncStreams
	Private connected As Boolean
	Private searchingForDevices As Boolean
	Private btc As BluetoothConnection
	Private lstDevices As ListView
	
	Private foundDevices As Map
	Private btnDisconnect As Button
	Private lblConnectionState As Label
	Private lblSearchState As Label
	
	Private dialog As B4XDialog
	
End Sub

public Sub initialize
	Private p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, 1000dip, 900dip)
	p.LoadLayout("fBTPage")
	dialog.Initialize(Main.MainForm.RootPane)
	dialog.BackgroundColor = xui.Color_RGB(20,20,30)
	dialog.ButtonsColor = xui.Color_RGB(0,120,190)
	'dialog.BlurBackground = True
	'dialog.BodyTextColor = 15794175
	dialog.PutAtTop = True
	'Wait For (dialog.ShowCustom(p, "Ok!", "No!", "")) Complete (Result As Int)
	dialog.ShowCustom(p, "OK", "", "")
	
	bt.Initialize("bt")
	foundDevices.Initialize
	If bt.IsEnabled Then
		bt.Listen
	End If
	UpdateState
End Sub

Private Sub UpdateState
	If bt.IsEnabled = False Then
		lblSearchState.Text = "Bluetooth not available"
	Else
		btnSearch.Enabled = Not(searchingForDevices)
		btnConnect.Enabled = Not(connected) And lstDevices.SelectedIndex > -1
		btnDisconnect.Enabled = connected
		Dim state As String
		If connected Then
			state = "Connected: " & btc.Name
		Else
			state = "Disconnected"
		End If
		lblConnectionState.Text = state
		lblSearchState.Text = "Searching..."
		lblSearchState.Visible = searchingForDevices
	End If
End Sub


Private Sub btnSearch_Action
	Dim res As Boolean = bt.StartDiscovery
	If res Then
		searchingForDevices = True
		lstDevices.Items.Clear
		UpdateState
	Else
		Log("Error starting discovery")
	End If
End Sub

Private Sub bt_DeviceFound (Name As String, MacAddress As String)
	Dim description As String = Name & ": " & MacAddress
	lstDevices.Items.Add(description)
	foundDevices.Put(description, MacAddress)
End Sub

Private Sub bt_DiscoveryFinished
	searchingForDevices = False
	UpdateState
End Sub

Private Sub btnConnect_Action
	Dim address As String = foundDevices.Get(lstDevices.SelectedItem)
	bt.Connect(address)
End Sub

Private Sub bt_Connected (Success As Boolean, connection As BluetoothConnection)
	Log($"Connected, success=${Success}"$)
	If Success Then
		btc = connection
		connected = True
		If astream.IsInitialized Then astream.Close
		astream.InitializePrefix(connection.InputStream, True, connection.OutputStream, "AStream")
	End If
	bt.Listen
	UpdateState
End Sub

Sub AStream_NewData (Buffer() As Byte)
	LogMessage("You", BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
End Sub


Sub AStream_Error
	connected = False
	UpdateState
End Sub

Sub AStream_Terminated
	AStream_Error
End Sub

Private Sub LogMessage(From As String, Msg As String)
	txtLog.Text = txtLog.Text & From & ": " & Msg & CRLF
	txtLog.SetSelection(txtLog.Text.Length, txtLog.Text.Length)
End Sub

Private Sub lstDevices_SelectedIndexChanged(Index As Int)
	UpdateState
End Sub

Private Sub btnDisconnect_Action
	btc.Disconnect
	If astream.IsInitialized Then astream.Close
	connected = False
	UpdateState
End Sub